$TASK 1

;====================================================================
;
;  Example software to implement UDP Server for messages exchange with notification
;
;====================================================================

; Structure for message send
LIT size_buffer_Request  16
; definition of structure to be sent to server
STRUCT_P buff_send
	U32 msgId
	I32 comando
	I32 reg_start
	I32 reg_num
END_STRUCT_P
; buff_request is the question
buff_send  buff_request

; answer structure
INT size_buffer_Answer  ; 16+....
STRUCT_P buff_recv
	I32  msgId
	I32  comando
	I32  reg_start
	I32  reg_num
	REAL regs[30]
END_STRUCT_P
; buff_answer is the answer
buff_recv  buff_answer

string ip_server_addr  = "192.168.1.130"
U32 udp_server_port = 18000 		; The server answer on the port 18000
I32 codOpen, codSend, codRecv, reso
I32 i
U32 ip_server_num   				; Ip adress after str_to_ipaddr function
INT size_bufferRq 					; size buffer for answer

LIT IDX_START 1000					; start index register for the client
; registers
LIT rRegType    R(1)	; type of server register
	LIT REQ_R		1
	LIT REQ_RR		2
	LIT REQ_NVR		3
	LIT REQ_NVRR	4

LIT rRegStart	R(2)	; start index register for the server
LIT rNumReg		R(3)	; repetition

int vai
real T1, DT1
bool flag_Loop


;*********************************************************************************
; CODE BEGIN
;*********************************************************************************



;*********************************************************************************
call initTask()



;*********************************************************************************
__MAIN_LOOP__

	; comand preparation
	buff_request.comando   = rRegType		; register tipology
	buff_request.reg_start = rRegStart		; index register start
	buff_request.reg_num   = in_range (rNumReg	,0,30)	; how many

	flag_Loop = true
	
	; command send
	codSend = UDP_SEND_NOTIFY(codOpen, buff_request, size_buffer_request)
	T1 = time_micro()
	if (codSend < 0)
		; Error
		ALARM_SET(4002,0,codSend) ; "4002 error send_notify (client)"
		continue
	endif

	; OK...let's receive the server answer
	size_buffer_answer = evalSize(buff_request.comando,buff_request.reg_num)
	WHILE (flag_Loop)
		; let's see if the message from the server is arrived
		codRecv = UDP_RECV_NOTIFY(codOpen, buff_answer, size_buffer_answer, 0.2, 2)
		IF (codRecv = 0)
			; The answer is not yet arrived
			CONTINUE
		ENDIF

		IF (codRecv < 0)
			; Error
			ALARM_SET(4003,0,codRecv); "4003 error recv_notify (client)"
			DWELL (1)
			flag_Loop = false
		endif

		IF(flag_Loop)
			;  messaggio ricevuto OK...
			; OK...let's receive the server answer
			DT1 = time_micro()  - T1

			SELECT(buff_request.comando)
				CASE REQ_R
					FOR (i=0, i<buff_answer.reg_num, i=i+1)
						R(IDX_START+i) = (INT) buff_answer.regs[i]
					END_FOR
				BREAK
				CASE REQ_RR
					FOR (i=0, i<buff_answer.reg_num, i=i+1)
						RR(IDX_START+i) = buff_answer.regs[i]
					END_FOR
				BREAK
				CASE REQ_NVR
					FOR (i=0, i<buff_answer.reg_num, i=i+1)
						NVR(IDX_START+i) = (INT) buff_answer.regs[i]
					END_FOR
				BREAK
				CASE REQ_NVRR
					FOR (i=0, i<buff_answer.reg_num, i=i+1)
						NVRR(IDX_START+i) = buff_answer.regs[i]
					END_FOR
				BREAK
			END_SELECT
		endif
	BREAK
	END_WHILE
	
END_MAIN_LOOP




;°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°
;°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°
;  F U N C T I O N S
;°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°
;°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°



;*********************************************************************************
function initTask

	; set the exchange area
	rRegType  = REQ_RR
	rRegStart = 1000
	rNumReg   = 30

	; IP Server string conversion
	reso = str_to_ipaddr(ip_server_addr, ip_server_num)
	; diagnostic
	if (reso = 0)
		; Error
		alarm_set(4000) ; "4000 err. adress"
	endif
	; Let's open the CLIENT comunication
	codOpen = udp_open_client(udp_server_port, ip_server_num)

	; diagnostic
	if (codOpen < 0)
		; Error
		alarm_set(4001,0,codOpen) ; "4001 err. udp_open (client)"
	endif

end_fun




;*********************************************************************************
FUNCTION INT evalSize(I32 type , I32 quanti)
int reso
	SELECT(type)
			CASE REQ_R
				reso = 16 + 8 * quanti
			BREAK
			CASE REQ_RR
				reso = 16 + 8 * quanti
			BREAK

			CASE REQ_NVR
				reso = 16 + 8 * quanti
			BREAK
			CASE REQ_NVRR
				reso = 16 + 8 * quanti
			BREAK

			DEFAULT
				reso = 0
			BREAK
		END_SELECT
	RETURN reso
END_FUN

