$TASK 1

;===================================================================================
;
;  Example software to implement UDP Server for messages exchange with notification
;
;===================================================================================
; struct to send commands
LIT size_buffer_request  16
; definition of structure to be sent to the server
STRUCT_P buff_send
	U32 msgId
	I32 comando
	I32 reg_start
	I32 reg_num
END_STRUCT_P
; buff_request is the question
buff_send  buff_request


; answer structure
INT size_buffer_answer  ;;;256 ; 16+8*30
STRUCT_P buff_recv
	I32  msgId
	I32  comando
	I32  reg_start
	I32  reg_num
	REAL regs[30]
END_STRUCT_P
; buff_answer is the answer
buff_recv  buff_answer


string ip_server_addr  = "192.168.1.130"
string ip_client_addr  = "192.168.1.131"
U32 udp_server_port = 18000 ; server is connected on port 18000
I32 codOpen, codSend, codRecv, reso
I32 i
U32 ip_server_num   	; server addres after str_to_ipaddr
U32 ip_client_num   	; client addres after str_to_ipaddr
INT size_bufferRq 	; size buffer for answer
int appo_address		; used to store address

LIT REQ_R		1
LIT REQ_RR		2
LIT REQ_NVR		3
LIT REQ_NVRR		4


;*********************************************************************************
; CODE BEGIN
;*********************************************************************************



;---------------------------------------------------------------------------------------------
call initTask()



;---------------------------------------------------------------------------------------------
__MAIN_LOOP__

	; let's get the message from the client
	codRecv = UDP_RECV_FROM(codOpen, buff_request, size_buffer_request, udp_server_port, ip_client_num )
	; wait for the server reception
	IF (codRecv < 0)
		; Error
		ALARM_SET(4003,0,codRecv) ; "4002 error recv_from (server)"
		continue
	endif

	IF (codRecv <> 0)
		;  ...question receive OK
		;  let's prepare the answer
		buff_answer.msgId     = buff_request.msgId
		buff_answer.comando   = buff_request.comando
		buff_answer.reg_num   = buff_request.reg_num
		buff_answer.reg_start = buff_request.reg_start
		appo_address = buff_answer.reg_start
		
		SELECT(buff_answer.comando)
			CASE REQ_R
				FOR (i=0, i<buff_answer.reg_num, i=i+1)
					buff_answer.regs[i] = (REAL) R(appo_address+i)
				END_FOR
				size_buffer_answer = 16 + 8 * buff_answer.reg_num
			BREAK
			CASE REQ_RR
				FOR (i=0, i<buff_answer.reg_num, i=i+1)
					buff_answer.regs[i] = RR(appo_address+i)
				END_FOR
				size_buffer_answer = 16 + 8 * buff_answer.reg_num
			BREAK

			CASE REQ_NVR
				FOR (i=0, i<buff_answer.reg_num, i=i+1)
					buff_answer.regs[i] = (REAL) NVR(appo_address+i)
				END_FOR
				size_buffer_answer = 16 + 8 * buff_answer.reg_num
			BREAK
			CASE REQ_NVRR
				FOR (i=0, i<buff_answer.reg_num, i=i+1)
					buff_answer.regs[i] = NVRR(appo_address+i)
				END_FOR
				size_buffer_answer = 16 + 8 * buff_answer.reg_num
			BREAK

		END_SELECT

		; Send the answer
		codSend = UDP_SEND_TO(codOpen, buff_answer, size_buffer_answer, udp_server_port, ip_client_num)
		IF (codRecv < 0)
			; Error
			ALARM_SET(4004,0,codSend) ; "4004 error udp_send_to (server)"
			continue
		endif
	endif

END_MAIN_LOOP




;---------------------------------------------------------------------------------------------
function initTask

	; IP SERVER string conversion
	reso = str_to_ipaddr(ip_server_addr, ip_server_num)
	; diagnostic
	if (reso = 0)
		; Error
		alarm_set(4000) ; "4000 err. adress Server"
	endif

	; IP CLIENT string conversion
	reso = str_to_ipaddr(ip_client_addr, ip_client_num)
	; diagnostic
	if (reso = 0)
		; Error
		alarm_set(4001) ; "4001 err. adress Client"
	endif

	; Let's open SERVER comunication
	codOpen = UDP_OPEN_SERVER(udp_server_port, ip_server_num )

	; diagnostic
	if (codOpen < 0)
		; Error
		alarm_set(4002,0,codOpen) ; "4001 err. udp_open (client)"
	endif

end_fun

